#include "usermanager.h"
#include <QFile>
#include <QTextStream>

UserManager::
UserManager(ushort cryptoKey, QString opseq, 
            ushort charsiz/* = 128*/)  :    
    m_Cryptor(cryptoKey, opseq, charsiz) { }

int UserManager::
findUser(QString userid, const QString& pw) {
    int indx, size(m_useridList.size());
    QString cryptpw(m_Cryptor.encrypt(pw));
    for (indx = 0; indx < size; ++ indx) 
        if (userid == m_useridList.at(indx) && 
           cryptpw == m_pwList.at(indx)) 
            return indx;
    return -1;
}

bool UserManager::
changePW(QString userid, QString oldPW, 
         QString newPW)  {
    int indx = findUser(userid,  oldPW);
    if (indx == -1) return false;
    m_pwList[indx] = m_Cryptor.encrypt(newPW);
    return true;
}
    
bool UserManager::
addUser(QString userid, QString pw) {
    // First make sure userid does not already exist.
    if (findUser(userid, pw) != -1) return false;
    m_useridList.append(userid);
    m_pwList.append(m_Cryptor.encrypt(pw));
    return true;
}

bool UserManager::
checkUser(QString userid, QString pw) {
    int indx = findUser(userid, pw);
    return indx != -1;
}

int UserManager::
saveList() const {
    QString separator("***ZONE***");
    QString userids(m_useridList.join(separator));
    QString passwords(m_pwList.join(separator));
    QFile outfile("pwfile");
    if (outfile.open(QFile::WriteOnly)) {
        QTextStream of(&outfile);
        of << userids << '\n' ;
        of << passwords << endl;
        outfile.close();
        return m_useridList.size();
    }
    else
        return 0;
}

int UserManager::
loadList() {
    QString separator("***ZONE***");
    QString userids;
    QString passwords;
    QFile infile("pwfile");
    if (infile.open(QFile::ReadOnly)) {
        QTextStream inf(&infile);
        userids = inf.readLine();
        passwords = inf.readLine();
        m_useridList.clear();
        m_useridList = userids.split(separator);
        m_pwList.clear();
        m_pwList = passwords.split(separator);
        if (m_useridList.size() == m_pwList.size())
            return m_useridList.size();
        return 0;
    }
    else
        return 0;
}

void UserManager::   /* for debugging purposes */
listUsers()  {
    QTextStream cout(stdout, QIODevice::WriteOnly);
    QTextStream cin(stdin, QIODevice::ReadOnly);
    int count(m_useridList.size());
    cout << "userid\tpassword\n" ;
    for (int i=0; i < count; ++i)
        cout << m_useridList[i] << '\t' 
                << m_Cryptor.decrypt(m_pwList[i]) << '\n';
    cout << endl;
}
